#include "prehtml.h"

char *listefonctions[]={
  "shell","echo","echonoesc",
    "shellecho","shellechonoesc",
    "chut","/chut","error","warning",    /* commandes immdiates*/
    "if","else","fi","for","while","done", 
    "include","notinclude","reinclude",  /* commandes imbriques*/
    "generate","/generate", /* pas immdiates, mais pas imbricables */
    "body","/body",   /* pour l'inclusion du corps seul, sans enttes */
    NULL                    /* c'est tout!*/
};
int a_decoder; /* vrai si fonction type "&lt;if"*/

char *chaine; /* chaine qui suit le code de la fonction */
static int longueur; /* taille rserve pour chaine*/
static int pchaine; /*nb de caractres rentrs dans chaine */
char fonction[30]; /* nom de la fonction */

static struct{char c,code[7];} escape[]={
{'"',"quot\0"}, /* le recodage est facultatif */
{'&',"amp\0"},
{'<',"lt\0"},
{'>',"gt\0"},
{' ',"nbsp\0"}, /* seulement dcoder, pas recoder */
{'',"iexcl\0"},
{'',"cent\0"},
{'',"pound\0"},
{'',"curren\0"},
{'',"yen\0"},
{'',"brvbar\0"},
{'',"sect\0"},
{'',"uml\0"},
{'',"copy\0"},
{'',"ordf\0"},
{'',"laquo\0"},
{'',"not\0"},
{'',"shy\0"},
{'',"reg\0"},
{'',"macr\0"},
{'',"deg\0"},
{'',"plusmn\0"},
{'',"sup2\0"},
{'',"sup3\0"},
{'',"acute\0"},
{'',"micro\0"},
{'',"para\0"},
{'',"middot\0"},
{'',"cedil\0"},
{'',"sup1\0"},
{'',"ordm\0"},
{'',"raquo\0"},
{'',"frac14\0"},
{'',"frac12\0"},
{'',"frac34\0"},
{'',"iquest\0"},
{'',"Agrave\0"},
{'',"Aacute\0"},
{'',"Acirc\0"},
{'',"Atilde\0"},
{'',"Auml\0"},
{'',"Aring\0"},
{'',"AElig\0"},
{'',"Ccedil\0"},
{'',"Egrave\0"},
{'',"Eacute\0"},
{'',"Ecirc\0"},
{'',"Euml\0"},
{'',"Igrave\0"},
{'',"Iacute\0"},
{'',"Icirc\0"},
{'',"Iuml\0"},
{'',"ETH\0"},
{'',"Ntilde\0"},
{'',"Ograve\0"},
{'',"Oacute\0"},
{'',"Ocirc\0"},
{'',"Otilde\0"},
{'',"Ouml\0"},
{'',"times\0"},
{'',"Oslash\0"},
{'',"Ugrave\0"},
{'',"Uacute\0"},
{'',"Ucirc\0"},
{'',"Uuml\0"},
{'',"Yacute\0"},
{'',"THORN\0"},
{'',"szlig\0"},
{'',"agrave\0"},
{'',"aacute\0"},
{'',"acirc\0"},
{'',"atilde\0"},
{'',"auml\0"},
{'',"aring\0"},
{'',"aelig\0"},
{'',"ccedil\0"},
{'',"egrave\0"},
{'',"eacute\0"},
{'',"ecirc\0"},
{'',"euml\0"},
{'',"igrave\0"},
{'',"iacute\0"},
{'',"icirc\0"},
{'',"iuml\0"},
{'',"eth\0"},
{'',"ntilde\0"},
{'',"ograve\0"},
{'',"oacute\0"},
{'',"ocirc\0"},
{'',"otilde\0"},
{'',"ouml\0"},
{'',"divide\0"},
{'',"oslash\0"},
{'',"ugrave\0"},
{'',"uacute\0"},
{'',"ucirc\0"},
{'',"uuml\0"},
{'',"yacute\0"},
{'',"thorn\0"},
{'',"yuml\0"},
{'\0',"\0"}};
  
char *recodeHTML(char *s){ /* fait les chappements HTML, et alloue de
			    * la mmoire pour la chane rsultante*/
  char *ligne;
  int longueur,pligne=0,in=0,i,car;
  ligne=monalloc(longueur=LONGUEUR_LIGNE);
  while((car=s[in])){
    for(i=0;escape[i].c;i++){
      if (escape[i].c==car) if (car!='"' && car!=' ') break;
    }
    if (escape[i].c){ /* on a trouv un caractre  chapper */
      ligne[pligne]='&';
      strcpy(ligne+pligne+1,escape[i].code);
      pligne+=strlen(escape[i].code)+2;
      ligne[pligne-1]=';';
    }
    else{
      /* Ce n'est pas un caractre  coder spcialement: */
      /*   regardons si c'est _lt_, _gt_, ou _und_ */
      if (car=='_'){
	if (!strncmp(s+in,"_lt_",4)){
	  in+=3;car='<';
	}else if (!strncmp(s+in,"_gt_",4)){
	  in+=3;car='>';
	}else if (!strncmp(s+in,"_und_",5)){
	  in+=4;car='_';
	}
      }
      ligne[pligne++]=car;
    }
    in++;
    if (pligne > longueur - 10){
      ligne=realloc(ligne,longueur=longueur+LONGUEUR_LIGNE);
      if (!ligne) erreur("recodeHTML(): pas assez de mmoire");
    }
  }
  ligne[pligne]='\0';
  return ligne;
}

void nettoiechaine(void){ /* si a_decode, traduit les codes HTML de chaine;
			   * de toute faon enlve le > final et les \n */
  char *pchaine=chaine,
    *p2chaine,code[40];
  int i,p2;
  char c;
  
  /* vrifie qu'on a bien <... > ou &lt;...&gt; */ 
  /* non non, je ne vrifie pas, car Netscape Composer fait
   * presque toujours des &gt;.....>
   * C'est laid, mais Netscape Composer le fait et je l'utilise */
  //  if (a_decoder && chaine[strlen(chaine)-1]=='>')
  //    warning("commande \"<%s\" en HTML se termine par >",
  //	    fonction);
  //  if ((!a_decoder) && chaine[strlen(chaine)-1]!='>')
  //    warning("Attention: commande \"<%s\" en ASCII ne se termine pas par >\n",
  //	    fonction);
  
  /* dcode les chappements HTML */
  a_decoder=1; /* ON MET TOUJOURS  DCODER, C'EST ENCORE LE PLUS PRATIQUE */
  if (a_decoder) while ((pchaine=strchr(pchaine,'&'))){
    p2chaine=strchr(pchaine,';');
    if ((!p2chaine) || (p2chaine-pchaine)>=39){ /* pas de ; ou trop long*/
      pchaine++;
      continue;
    }
    memmove(code,pchaine+1,p2chaine-pchaine-1);
    code[p2chaine-pchaine-1]='\0';
    for(i=0;escape[i].c;i++)
      if (!strcmp(code,escape[i].code)){
	*pchaine=escape[i].c;
	strcpy(pchaine+1,p2chaine+1);
	break;
      }
    pchaine++;
  }
  
  /* remplace les '\n' par ' ' */
  for (i=0;chaine[i];i++) if (chaine[i]=='\n') chaine[i]=' ';
  
  /* on devrait avoir un '>'  la fin, et on l'enlve, ou sinon on signale l'erreur (fatale)*/
  i=strlen(chaine)-1;
  if (chaine[i]!='>') {
    if (i>=3 && !strcmp(chaine+i-3,"&gt;")) chaine[i-3]='\0';
    else {
      erreur("La commande <%s ne se termine pas par >",fonction);
    }
  }
  chaine[i]='\0';

  /* remplace "<" et ">" par "_lt_", "_gt_", et si ncessaire "_" par "_und_"*/
  p2chaine=monalloc(longueur=LONGUEUR_LIGNE);
  p2=0;
  for(pchaine=chaine;*pchaine;pchaine++){
    c=*pchaine;
    if (c=='_'){
      if ((!strncmp(pchaine,"_lt_",4)) ||
	  (!strncmp(pchaine,"_und_",5))||
	  (!strncmp(pchaine,"_gt_",4)))
	{strcpy(code,"_und_");c='\0';}
    }
    else if (c=='<') {strcpy(code,"_lt_");c='\0';}    
    else if (c=='>') {strcpy(code,"_gt_");c='\0';}
    if (c) p2chaine[p2++]=c;
    else{
      strcpy(p2chaine+p2,code);
      p2+=strlen(code);
    }
    if (p2 > longueur - 10){
      p2chaine=realloc(p2chaine,longueur=longueur+LONGUEUR_LIGNE);
      if (!p2chaine) erreur("nettoiechaine(): pas assez de mmoire");
    }
  }
  p2chaine[p2]='\0';
  free(chaine);
  chaine=p2chaine;
}


int decode(void){ /* renvoie un caractre, ou EOF si fini,
		   * ou EST_FONCTION si a trouv un fonction
		   * (ce qui demande de lire quelle_fonction() )*/
  int c,cmin,premiercar;
  int i;
  int html;
  premiercar=c=mongetc();
  if (premiercar=='&'){
    stocke(); /* c'est peut-tre le dbut de &lt; */
    i=0;
    if (mongetc()=='l')
      if (mongetc()=='t')
	if (mongetc()==';') i=1;
    if (!i) {
      destocke(); return c; /* dsol, c'tait une erreur */
    }
    a_decoder=1; /* a dmarre par &lt;, c'est donc du HTML */
  }
  else if (premiercar=='<') {
    stocke();
    a_decoder=0; /* a dmarre par <, c'est donc du ASCII */
  }
  else return c; /* OK, c'est un caractre qui ne pose pas de question */
  /* si on est l, c'est qu'on a vu "<" ou "&lt;", et on stocke */
  /* on lit le nom de la fonction*/
  for (i=0;i<29;i++){
    c=mongetc();
    if (i==0) 
      while (c==' ') c=mongetc(); /* on enlve les espaces aprs '<' */
    cmin=tolower(c);
    if (c!='/'&&(cmin<'a' || cmin>'z')) break; /*  '/' et minuscules */
    fonction[i]=cmin; /* en minuscules SVP */
  }
  fonction[i]='\0';
  /* est-ce que a correspond  une fonction? */
  for(i=0;;i++){
    if (!listefonctions[i]){ /* on arrive sur NULL, a ne correspond pas*/
      destocke();
      return premiercar;
    }
    if (!strcmp(listefonctions[i],fonction)){
      /* on a trouv une fonction, mais attention, car si c'est <BODY> ou
       * </BODY> et qu'on est dans le fichier principal, il faut la laisser
       * (ainsi que si on est dans un <REINCLUDE> */
      /* si ce n'est pas "body" ni "/body", a va, je l'accepte */
      if ((strcmp(fonction,"body") && strcmp(fonction,"/body"))) break;
      /* si c'est dans un <REINCLUDE>, je n'accepte que </body> */
      if (flag_reinclude){
	if (!strcmp(fonction,"/body")) break;
      }
      /* sinon, hors du fichier principal, j'accepte <body> et </body> */
      else if (fichier_courant->pere) break;
      /* autres cas: je l'ignore */
    }
  }
  /* OK, c'est donc la fonction i */
  finstocke(); /* on limine donc ce qu'on a stock '<fonction#" */
  chaine=monalloc((longueur=LONGUEUR_LIGNE));
  pchaine=0;
  html=0; /* on n'est pas dans une balise HTML */
  while(1){
    if (c==EOF) erreur("EOF rencontr dans l'argument de <%s",fonction);
    chaine[pchaine++]=c;
    if (pchaine>=longueur-3){
      chaine=realloc(chaine,longueur=longueur+LONGUEUR_LIGNE);
      if (!chaine) erreur("decode(): pas assez de mmoire pour lire "
			 "l'argument de <%s",fonction);
    }
    if (c=='<') html=1; /* on rentre dans une balise HTML*/
    if (c=='>'){
      if (html) html=0; /* on sort de la balise HTML */
      else break; /* fin de la commande prehtml */
//    if (chaine[pchaine-1]=='>') break;
    }
    if (pchaine>=4) if (!strncasecmp(chaine+pchaine-4,"&gt;",4)) 
	break; /* la commande prehtml peut galement se terminer ainsi */
    c=mongetc();
  }
  chaine[pchaine]=0;
  nettoiechaine();
  //printf("Trouve la fonction <%s> avec l'argument '%s'\n",fonction,chaine);
  return EST_FONCTION;
  
}
